package kolokvijum;

public abstract class Radnik {
	private String ime, prezime;
	private double koeficijent, osnovica;
	private int staz;

	public Radnik() {

	}

	public Radnik(String ime, String prezime, double koeficijent, double osnovica, int staz) {
		this.ime = ime;
		this.prezime = prezime;
		setKoeficijent(koeficijent);
		setOsnovica(osnovica);
		setStaz(staz);
	}

	public String getIme() {
		return ime;
	}

	public void setIme(String ime) {
		this.ime = ime;
	}

	public String getPrezime() {
		return prezime;
	}

	public void setPrezime(String prezime) {
		this.prezime = prezime;
	}

	public double getKoeficijent() {
		return koeficijent;
	}

	public void setKoeficijent(double koeficijent) {
		if (koeficijent < 0)
			throw new IllegalArgumentException("Koeficijent ne moze biti negativan!");
		this.koeficijent = koeficijent;
	}

	public double getOsnovica() {
		return osnovica;
	}

	public void setOsnovica(double osnovica) {
		if (osnovica < 0)
			throw new IllegalArgumentException("Osnovica ne moze biti negativna!");
		this.osnovica = osnovica;
	}

	public int getStaz() {
		return staz;
	}

	public void setStaz(int staz) {
		if (staz < 0)
			throw new IllegalArgumentException("Staz ne moze biti negativan!");
		this.staz = staz;
	}

	public abstract double plata();

	// ovo smo mogli koristiti pri racunanju plata za programere i administrativce
	// kako ne bismo ponavljali kod... ostavljeno kao ideja
	public double osnovaPlate(double koefStaza) {
		return osnovica * koeficijent * (1 + staz / koefStaza);
	}

	@Override
	public String toString() {
		return ime + " " + prezime + " staz: " + staz;
	}

}
